*______________________________________________________________________________;
*                                                                              ;
*                B O O T S T R A P   R E S A M P L I N G                       ;
*                                                                              ;
*               B A G G I N G   S U M M A R I Z A T I O N                      ;
*______________________________________________________________________________;
*                                                                              ;
  %MACRO SUMBOOT(IN=IN, OUT=TMEANS, NOPRINT=0);
*______________________________________________________________________________;
*                                                                              ;
* DEFINITIONS OF CALLING ARGUMENTS:                         DEFAULT:           ;
*                                                                              ;
*   IN       = Input data set name                          IN                 ;
*   OUT      = Output dataset name, early phase             TMEANS             ;
*   NOPRINT  = Do not print output                          0                  ;
*______________________________________________________________________________;
*                                                                              ;
* Get data set size                                                            ;
  data &in; set &in nobs=num; _nobs_=num;
  if _n_=1 then call symput('DS_SIZE', _NOBS_); run;
*******************************************************************************;
* Output means and counts                                                      ;
  proc means n mean std min max data=&in noprint; output out=means;
* proc print data=means;
  data means; set means; drop _type_ _freq_ resampl _nobs_;
*******************************************************************************;
* Transpose these into column format                                           ;
  proc transpose data=means out=&out; id _stat_;
*******************************************************************************;
* Normalize frequency                                                          ;
  data &out; set &out;
    PCT=100*N/&DS_SIZE;
*******************************************************************************;
* Print                                                                        ;
  proc sort data=&out; by descending n;
  %IF &NOPRINT=0 %THEN %DO;
    proc print data=&out; var _NAME_ N PCT MIN MAX MEAN STD;
  %END;
*******************************************************************************;
  %mend sumboot;
